#!/bin/bash

# Launcher for building tclMuPdf on Linux/MacOsX/MingW environments
#  using the standard GNU/C tool-chain 
#  Read build-notes.tx for further info

_THISCMD=$0

echo =================================
echo Preliminary checks .....
echo =================================

# currently only x64 architecture is supported, then no need for an input parameter

_ARCH=x64

# ... We presume the C-build environment is properly set ..
 

echo =================================
echo Preliminary checks ..... DONE.
echo =================================
echo

 function toLower {
 	echo $* | tr '[:upper:]' '[:lower:]'
 }                                   
_OS=$(uname -s)
_OS=$(toLower $_OS)

case $_OS in
  linux*)  _OS=linux
  ;;
  darwin*) _OS=darwin
  ;;
  mingw*|msys*|cygwin*)  _OS=win
  ;;
  *) echo Unsupported OS "$_OS"
     exit 1
     ;;
esac


 ## you can also pass extra args to make ...
shift
_MAKEOPTS="--no-builtin-rules --no-builtin-variables"  ;# you must be EXPLICIT !
make ${_MAKEOPTS} -f unix-makefile OS=${_OS} ARCH=${_ARCH}  $*
