
#include <tcl.h>
#include <tclOO.h>
#include "tcloo_util.h"


	// return Tcl_Class or NULL

Tcl_Class tcloox_getClass(Tcl_Interp *interp, const char *className) {
	Tcl_Object classObject;
	Tcl_Obj *nameObj = Tcl_NewStringObj(className,-1);
	Tcl_IncrRefCount(nameObj);
	if ((classObject = Tcl_GetObjectFromObj(interp, nameObj)) == NULL) {
		Tcl_DecrRefCount(nameObj);
		return NULL;
	}
	Tcl_DecrRefCount(nameObj);
	return Tcl_GetObjectAsClass(classObject);	
}


void tcloox_registerConstructor(Tcl_Interp *interp, Tcl_Class clazz, const Tcl_MethodType *methodTypePtr) {
	Tcl_ClassSetConstructor(interp, clazz,
		Tcl_NewMethod(interp, clazz, NULL, 0,
					  methodTypePtr,
					  NULL));
// ??  why the isPublic flag is 0 ??
}


void tcloox_registerDestructor(Tcl_Interp *interp, Tcl_Class clazz, const Tcl_MethodType *methodTypePtr) {
	Tcl_ClassSetDestructor(interp, clazz,
		Tcl_NewMethod(interp, clazz, NULL, 0,
					  methodTypePtr,
					  NULL));
// ??  why the isPublic flag is 0 ??
}


Tcl_Method tcloox_registerMethod( Tcl_Interp *interp, Tcl_Class clazz, const Tcl_MethodType *methodType ) {
	Tcl_Method method;
	Tcl_Obj *nameObj;
	
	nameObj = Tcl_NewStringObj(methodType->name,-1);
	Tcl_IncrRefCount(nameObj);
	method = Tcl_NewMethod(interp,clazz,nameObj,1,methodType,NULL);
	Tcl_DecrRefCount(nameObj);
	return method;
}


int tcloox_registerMethods( Tcl_Interp *interp, Tcl_Class clazz, const Tcl_MethodType *methods [] ) {
	for (int i = 0; methods[i] != NULL; ++i) {
		tcloox_registerMethod( interp, clazz, methods[i]);
	}
	return TCL_OK;
}
// -----------------------------------------------

int NoCloneMethod(
	Tcl_Interp* interp,		/* Tcl interpreter for error reporting */
	ClientData metadata,	/* Metadata to be cloned */
	ClientData* newMetaData	/* Where to put the cloned metadata */
) {
	//  TODO ... retrive the class name 
	char * classname = "..THESE...";
	Tcl_SetObjResult(interp, Tcl_ObjPrintf("%s objects are not clonable",classname));
	return TCL_ERROR;
}
